## 为什么选择golang

调度任务系统一般负责触发任务，而执行任务的一般是业务系统，这个时候，很多任务对于调度系统来说都是阻塞的。
所以调度系统是IO密集型而非CPU密集型。Java开发调度系统，需要非常多的线程，一般会达到几百，甚至几千几万个线程。
CPU大量的工作用来做系统线程切换。golang的goroutine非常适和任务多，IO密集型的任务调度系统。

## 功能设计
* 支持cron表达式创建任务
* 支持简单语句创建任务，比如"每天1点执行","每次10分钟执行一次"等
* 支持接入golang，java等sdk方式调度任务
* 支持常见的如grpc，dubbo协议等
* 任务分组，一般情况下，调度系统会创建很多任务，我们需要根据任务进行分组，分组后可以设置权限。但是不能和appid绑定，因为实际业务调度并非和任务是一堆的。
* 立即触发任务
* 执行日志记录
* 任务告警
* 失败任务重试。

## 控制台
* 多租户(暂时不考虑)
* 分组管理，分组会有组名称等信息。
* 任务管理，任务包括，http任务(存储)，dubbo任务(存储)，rpc任务(存储)，sdk任务(自动和预存储)，任务名称，任务分组等。
* 调度管理，包括调度的任务是什么，分组是哪个，多负责人。
* 人员管理，增删改查人员信息。

## 结构设计
* doc文档类
* common 公共代码
* ops 控制台
* server 实际运行项目的节点

## 技术选型
* 通讯层 fasthttp
* 数据库层 gorm
* 界面 vue-element-ui

## 数据设计
* 存储mysql
* 服务端缓存数据
* ops支持在无mysql的情况下修改节点信息
* 支持mysql的动态停机和下线。
* 节点之间全量元数据管理

## 节点设计
* 无主设计，数据节点直接，基于数据块的1主2备。低于3个节点的时候全备。
* 所有节点，全量mysql数据库中的数据。采用ops通知和mysql时间重试机制，实现数据修改更新。

## 高可用设计
* 多节点部署防止单点故障
* 每个节点保存全量任务，通过redis抢锁实现分片
* 支持数据库宕机
* 基于"数据块"的主从，从节点和主节点不断心跳。一旦发现其中有一个块宕机了，立马寻找下一个备份。

## 容错相关